#line 1 "C:/Users/Usuario/Documents/Prog_AVR/DS18B20/DS18B20.c"


short int aux=0;
unsigned temp1;
char temp2;
const unsigned short TEMP_RESOLUTION = 12;

void Display_Temperature(unsigned int temp2write) {

 const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;

 if (temp2write & 0x8000) {
 temp2write = ~temp2write + 1;
 aux=1;
 }
 else aux=0;
 temp2 = temp2write >> RES_SHIFT ;
}
void set_up() {

 DDRC = 0xFF;
 DDRD = 0xFF;
 DDB1_bit = 1;
 PORTC = 0;
 PORTD = 0;
 PORTB.b1 = 0;

}
void Print_temp() {

unsigned char ch0, ch1, ch2;
short int i=0;
unsigned char display[10] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x67};

 for (i=0; i<=90; i++) {
 ch0 = temp2/100;
 PORTC = 1;
 PORTD = display[ch0] ;
 delay_ms(2);
 ch1 = (temp2/10) % 10;
 PORTC = 2;
 PORTD = display[ch1] ;
 delay_ms(2);
 ch2 = temp2 % 10;
 PORTC = 4;
 PORTD = display[ch2];
 delay_ms(2);
 }
}
void main() {
 set_up();
 while (1){
 Ow_Reset(&PORTB, 2);
 Ow_Write(&PORTB, 2, 0xCC);
 Ow_Write(&PORTB, 2, 0x44);
 Delay_us(120);
 Ow_Reset(&PORTB, 2);
 Ow_Write(&PORTB, 2, 0xCC);
 Ow_Write(&PORTB, 2, 0xBE);
 temp1 = Ow_Read(&PORTB, 2);
 temp1 = (Ow_Read(&PORTB, 2) << 8) + temp1;
 Display_Temperature(temp1);
 Print_temp();
 if(aux==1) PORTB.b1 = 1;
 else PORTB.b1 = 0;
 }
 }
